Pipelines API

Define and run CI/CD pipelines to automate build, test, and deploy workflows.

List Pipelines

GET /api/v1/pipelines
[
  {
    "id": "pipe_a1b2c3d4",
    "name": "deploy-production",
    "app_id": "app_e5f6g7h8",
    "trigger": "push",
    "branch": "main",
    "steps": ["build", "test", "deploy"],
    "created_at": "2024-01-15T10:30:00Z"
  }
]

Create a Pipeline

POST /api/v1/pipelines
name
string
required
Pipeline name
app_id
string
required
App to deploy
trigger
string
Trigger type: push, manual, or schedule
branch
string
Git branch to watch
steps
string[]
Pipeline steps
{
  "name": "deploy-production",
  "app_id": "app_e5f6g7h8",
  "trigger": "push",
  "branch": "main",
  "steps": ["build", "test", "deploy"]
}

Delete a Pipeline

DELETE /api/v1/pipelines/{id}

Pipeline Runs

List Runs

GET /api/v1/pipelines/{id}/runs
[
  {
    "id": "run_001",
    "pipeline_id": "pipe_a1b2c3d4",
    "status": "success",
    "duration_ms": 45000,
    "started_at": "2024-01-15T10:30:00Z",
    "finished_at": "2024-01-15T10:30:45Z"
  }
]

Trigger a Run

POST /api/v1/pipelines/{id}/runs
Manually trigger a pipeline execution.

Run Status

StatusDescription
pendingQueued for execution
runningCurrently executing
successAll steps completed successfully
failedOne or more steps failed
cancelledManually cancelled